Subject: RE: Incorrect source address on multicast packets on multihomed m achines?

From: Phil Irey <[email-masked]>
Date: Tue, 23 Jun 1998 11:15:37 -0400

Amritansh Raghav writes:
 > the address on the packets are different probably because the socket used to
 > send the data is binding to either INADDR_ANY or to an address not on the
 > interface on which the packets are sent

Actually, the address is bound to a specific interface with the
IP_MULTICAST_IF setsockopt.  Unfortunately, the source IP address of
multicast packets generated corresponds to the IP address of the
ethernet interface of the host and not the address specified with the
IP_MULTICAST_IF even though the packet is sent via that interface.

phil

 > 
 > > -----Original Message-----
 > > From:	Phil Irey [SMTP:[email-masked]]
 > > Sent:	Monday, June 22, 1998 1:20 PM
 > > To:	John M. Zwiebel
 > > Cc:	[email-masked]
 > > Subject:	Re: Incorrect source address on multicast packets on
 > > multihomed machines? 
 > > 
 > > John,
 > > 
 > > Thanks for the response.  We will take a look at the options of the ip
 > > mroute command if we can't get a fix for the Sun system (assuming that
 > > they are broken in some way).
 > > 
 > > With respect to your question: 
 > > 
 > > > WRT the source address that is used with the ATM interface, would you
 > > think
 > > > it was correct to place a different address in the source if it was a
 > > > unicast packet?
 > > 
 > > As with unicast packets, we would expect the source IP address of a packet
 > > sent by a host to be that of the interface on which the packet was
 > > sent.  (I'm only talking about the source host and not intermetiate
 > > systems.)  What we are seeing on the Suns is that the source IP
 > > address is always that of the ethernet even though we specify that the
 > > multicast packet be sent via ATM in our application.  The packet is
 > > sent from the source host over the ATM interface but with the IP
 > > address of the ethernet interface of the source host.  The FDDI
 > > interface behaves the same way.
 > > 
 > > Is this acceptable behavior or is the Sun choosing the wrong source IP
 > > address?  We are speculating that the Sun is doing something wrong.
 > > Since we only have access to SGI boxes and Sun boxes it is hard to
 > > tell which boxes are operating correctly or if both sets of boxes are
 > > operating correctly. Is there some way to change the behavior of the
 > > Sun? 
 > > 
 > > We talked to Cisco tech support who helped us narrow down the problem
 > > to the source IP address in question.  They indicated that multicast
 > > packets with a source IP addresses of a different network are rejected
 > > by the routing loop detection mechinsms in the router.   If this is
 > > true, I would expect that something has to change on the Sun for us to 
 > > get this to work properly.  Would you agree with this?
 > > 
 > > thanks,
 > > 
 > > phil
 > > 
 > > 
 > > 
 > > 
 >